import { DocumentNode, GraphQLSchema } from "graphql";
import { EventBusPlugin } from "./VanillaEventBus";
export declare type EventBusSubscriberCb = (props: {
    key: string;
    data: {};
}, ...args: any[]) => Promise<unknown>;
export interface SubscriberConfig {
    queries: DocumentNode;
    schema: GraphQLSchema;
    cb: EventBusSubscriberCb;
}
export interface PublisherConfig {
    schema: GraphQLSchema;
}
export interface EventBusConfig {
    publisher?: PublisherConfig;
    subscriber?: SubscriberConfig;
    plugins?: EventBusPlugin[];
}
export declare type Publish = (props: {
    topicName: string;
    data: {};
}, ...args: any[]) => Promise<unknown>;
export declare abstract class EventBus {
    abstract init(): Promise<void>;
    abstract publish: Publish;
    abstract closeConsumer(): Promise<unknown>;
    abstract closePublisher(): Promise<unknown>;
}
