import { EventBusSubscriberCb, Publish } from "./EventBus";
import { DocumentNode, GraphQLSchema } from "graphql";
export declare type DataCb = (data: {}, ...args: any[]) => Promise<unknown>;
interface SubscriptionConfig {
    queries: DocumentNode;
    schema: GraphQLSchema;
    cb: EventBusSubscriberCb;
    getSubscription: (topic: string, cb: DataCb) => void;
}
declare type EventHook = (args: {
    topic: string;
    data: {};
}, ...rest: any[]) => void;
export interface EventBusPlugin {
    consumeStart?: (args: {
        topic: string;
        data: {};
    }, ...rest: any[]) => EventHook | void;
    consumeError?: (args: {
        topic: string;
        data: {};
    }, err: Error) => void;
    publishError?: (args: {
        topic: string;
        data: {};
    }, err: Error) => void;
    publishStart?: (args: {
        topic: string;
        data: {};
    }, ...rest: any[]) => EventHook | void;
}
export declare class VanillaEventBus {
    config: {
        publisher?: {
            schema: GraphQLSchema;
            publishInit?: (topics: string[]) => Promise<unknown>;
            publish: Publish;
        };
        subscriber?: SubscriptionConfig;
        plugins?: EventBusPlugin[];
    };
    private consumeValidator;
    private publishValidator;
    constructor(config: {
        publisher?: {
            schema: GraphQLSchema;
            publishInit?: (topics: string[]) => Promise<unknown>;
            publish: Publish;
        };
        subscriber?: SubscriptionConfig;
        plugins?: EventBusPlugin[];
    });
    init: () => Promise<void>;
    private consume;
    publish: Publish;
}
export {};
